/***************************************************************************
                          aa1affichev_adn.cpp  -  widgets gtk--
                 affichage complet de sequences d'ADN avec barre de defilement
                 status bar ... etc
                             -------------------
    begin                : Thu Oct 18 2001
    copyright            : (C) 2001 by Olivier Langella
    email                : Olivier.Langella@pge.cnrs-gif.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "aa1affichev_adn.h"

AA1afficheV_ADN::AA1afficheV_ADN(AAmultiADN * Pmultiadn): _Pmultiadn(Pmultiadn), _Petatjeuseq(Pmultiadn->get_Petatjeuseq()){


//creation des differents Packer droite et gauche du HPaned
	//_Petatjeuseq = new AAetatJeuSeq(this, jeuseq);
	
	_PajustementSeq = manage(new Gtk::Adjustment(0,0,0));	//l'ajustement

	_Ppartiedroite = manage ( new Gtk::Packer());
	_Ppartiegauche = manage ( new Gtk::Packer());
	
	_Pboutonseq = manage(new Gtk::Button(_("sequences")));	//bouton haut de la partie droite
		
	_Pboutonnom = manage(new Gtk::Button(_("names")));	// boutton haut partie gauche
		// connection au click sur le boutton
	_Pboutonnom->clicked.connect (slot (_Pmultiadn, &AAmultiADN::toutsel_handler));
	
	_Pboutonselect = manage(new Gtk::Frame(_("nb select")));	// sous forme de frame	//bas gauche
//	_Pboutonselect = manage(new Gtk::Button("nbre select"));	// sous forme de button
	_Plabelselect = manage(new Gtk::Label("0"));
	_Pboutonselect->add(*_Plabelselect);
	
	_PdefilH = manage(new Gtk::HScale());	// bas droite
		
	_PpackADN = manage(new AA1DscrollADN(this));	//le pack des sequences
	
	//cration de la fentre contenant la liste
	_Pscrolliste = manage(new ListeBio(*_PpackADN->get_vadjustment()));	
		//connection au changement de selection
	_Pscrolliste->getPliste()->selection_changed.connect(slot(_Pmultiadn, &AAmultiADN::select_handler));
	_Pscrolliste->set_policy(GTK_POLICY_NEVER,GTK_POLICY_AUTOMATIC);		//enleve les scrollbar
	//_Pscrolliste->set_policy(GTK_POLICY_NEVER,GTK_POLICY_NEVER);
	
	
//creation de la barre verticale
	_PdefilH->set_adjustment(_PajustementSeq);
	_PdefilH->set_update_policy(GTK_UPDATE_DISCONTINUOUS);
	_PdefilH->set_digits(0);


//rempli la partie droite
	_Ppartiedroite->add( * _Pboutonseq,
                   GTK_SIDE_TOP,
                   GTK_ANCHOR_NORTH,
                   GTK_FILL_X);

	_Ppartiedroite->add( * _PpackADN,
                   GTK_SIDE_TOP,
                   GTK_ANCHOR_CENTER,
                   GTK_FILL_X | GTK_FILL_Y | GTK_EXPAND);
               //    0, 8, 8, 8, 0);
	_Ppartiedroite->add( * _PdefilH,
                   GTK_SIDE_TOP,
                   GTK_ANCHOR_CENTER,
                   GTK_FILL_X);

//rempli la partie gauche
		_Ppartiegauche->add( *_Pboutonnom,
                   GTK_SIDE_TOP,
                   GTK_ANCHOR_NORTH,
                   GTK_FILL_X);

	_Ppartiegauche->add( *_Pscrolliste,
                   GTK_SIDE_TOP,
                   GTK_ANCHOR_CENTER,
                   GTK_FILL_X | GTK_FILL_Y | GTK_EXPAND);

	_Ppartiegauche->add( *_Pboutonselect,
                   GTK_SIDE_BOTTOM,
                   GTK_ANCHOR_SOUTH,
                   GTK_FILL_X);
	
//	_Pboutonselect->set_usize(60, _PdefilH->height()); ne marche pas!!!
	_Pboutonselect->set_usize(60, 30);
	
//rempli le HPaned
	add1(*_Ppartiegauche);
	add2(*_Ppartiedroite);
/*	add(_partiedroite,
                   GTK_SIDE_RIGHT,
                   GTK_ANCHOR_EAST,
                   GTK_FILL_X | GTK_FILL_Y | GTK_EXPAND);
	add(_listenomseq,
                   GTK_SIDE_LEFT,
                   GTK_ANCHOR_EAST,
                   GTK_FILL_X | GTK_FILL_Y | GTK_EXPAND);*/

	show();
}

AA1afficheV_ADN::~AA1afficheV_ADN(){
}

// fonction qui renvoie le nombre total de sequences
int AA1afficheV_ADN::getnbseq() const {
	return(get_Pjeuseq()->getnbseq());
	//return(0);
}


void AA1afficheV_ADN::fcreation(const JeuSeqBio & jeuseq) {
}

//fonction qui lie les changements dans la liste au changement du nbre de selections
void AA1afficheV_ADN::select_handler()	{
	ChaineCar selection;
	
	maj_selection();

	selection.AjEntier(get_nbseqselect());	// conversion int->string

	_Plabelselect->set(selection);	// rempli le label
}


// fonction qui renvoie le nbre de sequences selectionnees
int AA1afficheV_ADN::get_nbseqselect() {
	return _Pscrolliste->getPliste()->selection().size();	// ok pour List nbre de selection dans la liste
	return(0);
}

// fonction liee au toggle button de/selectionne tout
void AA1afficheV_ADN::toutsel_handler()	{
	int i;
	
	if ( get_nbseqselect() == getnbseq()) {	// si tout est selectionne
		desel_tout();													// deselectionne tout
	}
	else {																	// sinon
		for (i = 0; i < getnbseq(); i++) {		// (re)selectionne tout
			_Pscrolliste->getPliste()->select_item(i);
		}
	}
	maj_selection();
}

// fonction qui deselectionne tout
void AA1afficheV_ADN::desel_tout()	{
	int i;
	
	for (i = 0; i < getnbseq(); i++) {
		_Pscrolliste->getPliste()->unselect_item(i);
	}
}

/*void AA1afficheV_ADN::copier(JeuSeqBio & jeuseq) [
	_Pscrolliste->copier_select(jeuseq);
]
*/

void AA1afficheV_ADN::get_seq_selectionnee(JeuSeqBio & jeuseq) const {
	_Petatjeuseq->get_seq_selectionnees(jeuseq);
}

void AA1afficheV_ADN::maj_selection() {
//met  jour l'tat des slections
	_Petatjeuseq->reset_selection();

	Gtk::List::SelectionList & dlist(_Pscrolliste->getPliste()->selection());
	Gtk::List::SelectionList::iterator iter;

	// If there are no selected items there is nothing more
	// to do than just telling the user so
	if (dlist.size() == 0) {
		//g_print("Selection cleared\n");
		return;
	}

		// Get the list item from the selection list and grab string from label
	for (iter=dlist.begin();iter!=dlist.end();++iter) {
		//tabPseq.push_back(dynamic_cast<ElementListeADN*>((*iter)->get_child())->get_Pseq());
		_Petatjeuseq->selectionner(dynamic_cast<ElementListeADN*>((*iter)->get_child())->get_Pseq());
		//jeuseq.ajouter(*(dynamic_cast<ElementListeADN*>((*iter)->get_child())->get_Pseq()));
		//cerr << jeuseq.size();
	}

}


void AA1afficheV_ADN::suppr_seq_selectionnee() {
//suppression des squences slectionnes
	//ElementListeADN * PelementlisteADN;
	vector<SequenceADN *> Pseq;
  vector<Gtk::ListItem *> new_prisoner;	
	Gtk::List::SelectionList & dlist(_Pscrolliste->getPliste()->selection());
	Gtk::List::SelectionList::iterator iter;
	unsigned int i;
//	GList * listePaenlever = NULL;
//cerr << "void AA1afficheV_ADN::suppr_seq_selectionnee() debut"<< endl;

	// If there are no selected items there is nothing more
	// to do than just telling the user so
	if (dlist.size() == 0) {
		//g_print("Selection cleared\n");
		return;
	}
	for (iter=dlist.begin();iter!=dlist.end();++iter) {
		//PelementlisteADN = dynamic_cast<ElementListeADN*>((*iter)->get_child());
		Pseq.push_back(dynamic_cast<ElementListeADN*>((*iter)->get_child())->get_Pseq());

//cerr << 	PelementlisteADN <<endl;
		//stockage des lments de la liste  enlever (partie gauche)
	//	listePaenlever->add(PelementlisteADN);
		new_prisoner.push_back(*iter);
		//_Pscrolliste->getPliste()->unselect_child(*new_prisoner);
		//_Pscrolliste->suppr_seq(Pseq);
		
//		_PpackADN->suppr_seq(Pseq);

		//_Pscrolliste->getPliste()->remove(*new_prisoner);
		//_Pscrolliste->getPliste()->remove_items(iter, iter);
		//_Pscrolliste->getPliste()->unselect_child(*new_prisoner);
//cerr << "void AA1afficheV_ADN::suppr_seq_selectionnee() avant 1"<< endl;
	//	listePaenlever = g_list_append(listePaenlever, new_prisoner->get_user_data());
//cerr << "void AA1afficheV_ADN::suppr_seq_selectionnee() avant 2"<< endl;
//cerr << new_prisoner->get_user_data() << endl;
		
	}
	grab_focus();

	for (i=0; i < new_prisoner.size(); i++) {	
//cerr << "void AA1afficheV_ADN::suppr_seq_selectionnee() 1 " << i << endl;
		_Pscrolliste->getPliste()->unselect_child(*new_prisoner[i]);
//cerr << "void AA1afficheV_ADN::suppr_seq_selectionnee() 2"<< endl;
		_Pscrolliste->suppr_seq(Pseq[i]);
//cerr << "void AA1afficheV_ADN::suppr_seq_selectionnee()3"<< endl;
		_PpackADN->suppr_seq(Pseq[i]);
//cerr << "void AA1afficheV_ADN::suppr_seq_selectionnee() 4"<< endl;
		_Petatjeuseq->suppr_seq(Pseq[i]);
	}
	//suppression des lments slectionns dans la liste (partie gauche)
//cerr << "void AA1afficheV_ADN::suppr_seq_selectionnee() avant" << endl;
//cerr << listePaenlever->data << endl;
//	_Pscrolliste->getPliste()->remove_items(listePaenlever);
	//dlist.empty();
	show();
	
//cerr << "void AA1afficheV_ADN::suppr_seq_selectionnee() fin"<< endl;
}

void AA1afficheV_ADN::f_reversecomplement() {
//calcul du reverse complement des squences slectionnes
	//JeuSeqBio Pseq;
	SequenceADN * Pseq;

	Gtk::List::SelectionList & dlist(_Pscrolliste->getPliste()->selection());
	Gtk::List::SelectionList::iterator iter;

	// If there are no selected items there is nothing more
	// to do than just telling the user so
	if (dlist.size() == 0) {
		//g_print("Selection cleared\n");
		return;
	}

	// Ok, we got a selection and so we print it
	//g_print("The selection is a ");
//	cerr << dlist.size();

	// Get the list item from the selection list and grab string from label
	for (iter=dlist.begin();iter!=dlist.end();++iter) {
		//cerr << dynamic_cast<Gtk::Label*>((*iter)->get_child())->get().c_str();
		//cerr << dynamic_cast<ElementListeADN*>((*iter)->get_child())->get_Pseq()->gettitre();
		Pseq = dynamic_cast<ElementListeADN*>((*iter)->get_child())->get_Pseq();
		Pseq->fcomplement();
		_PpackADN->f_rafraichir_sequence(Pseq);
		//jeuseq.ajouter(*(dynamic_cast<ElementListeADN*>((*iter)->get_child())->get_Pseq()));
		//cerr << jeuseq.size();
	}
	show();
}

JeuSeqADN * AA1afficheV_ADN::get_Pjeuseq() const {
	return(_Petatjeuseq->get_Pjeuseq());
	
}

void AA1afficheV_ADN::Ajouter_ADN() {
	//_Petatjeuseq->Ajouter_ADN(jeuseq);
	_PpackADN->Ajouter_ADN();
}




