/***************************************************************************
                          aa2barreetat.cpp  -  description
                             -------------------
    begin                : Fri Oct 19 2001
    copyright            : (C) 2001 by Olivier Langella
    email                : Olivier.Langella@pge.cnrs-gif.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "aa2barreetat.h"
#include "aamultiadn.h"

AA2barreEtat::AA2barreEtat(const AAmultiADN * Pmultiadn): _Pmultiadn(Pmultiadn), _Petatjeuseq(Pmultiadn->get_Petatjeuseq()) {

	_Pbarrenbseq = manage( new Statusbar());

	_nbseltot_id = _Pbarrenbseq->get_context_id("selected sequences");
	
	_Pbarrenbseq->push(_nbseltot_id, "tot: 0 sel: 0");
	
	aff_nbselect();
	
	add(*_Pbarrenbseq);
	
	show();
}

AA2barreEtat::~AA2barreEtat(){
}

void AA2barreEtat::aff_nbselect() {
	unsigned int nbtot(_Petatjeuseq->get_Pjeuseq()->getnbseq());
	unsigned int nbselect(_Petatjeuseq->get_nbseq_selectionnees());
  char buff[30];

  _Pbarrenbseq->pop(_nbseltot_id);
  g_snprintf(buff, 30, "tot: %d sel: %d", nbtot, nbselect);
  _Pbarrenbseq->push(_nbseltot_id, buff);
}

void AA2barreEtat::Ajouter_ADN() {
	aff_nbselect();
}


void AA2barreEtat::select_handler()	{
	aff_nbselect();
}

