/***************************************************************************
                          aaetatjeuseq.cpp  -  description
                             -------------------
    begin                : Thu Oct 18 2001
    copyright            : (C) 2001 by Olivier Langella
    email                : Olivier.Langella@pge.cnrs-gif.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "aaetatjeuseq.h"

AAetatJeuSeq::AAetatJeuSeq(const JeuSeqBio & jeuseq):_jeuseqADN(jeuseq){
	//unsigned int i;
	
	//_Pjeuseqbio = Pjeuseqbio;
	_num_seq_focus = 9999;
//	_Paffichage = Paffichage;
	_modif = false;
	
	
	_tab_seq_sel.resize(_jeuseqADN.getnbseq());
	
	reset_selection();
}

AAetatJeuSeq::~AAetatJeuSeq(){
}

void AAetatJeuSeq::Ajouter_ADN(const JeuSeqBio & jeuseq) {
	unsigned int nbseq(_jeuseqADN.getnbseq()), i;
	
	_modif = true;
	_jeuseqADN += jeuseq;
	
	
	for (i=nbseq; i < _jeuseqADN.getnbseq(); i ++) {
		_tab_seq_sel.push_back(false);
	}
	
	
}

void AAetatJeuSeq::reset_selection () {
//remet les slections  zro
	unsigned int i;
	for (i=0; i < _tab_seq_sel.size(); i ++) {
		_tab_seq_sel[i] = false;
	}

}

void AAetatJeuSeq::selectionner (const SequenceADN * Pseq) {
	unsigned int i;
	for (i=0; i < _tab_seq_sel.size(); i ++) {
		if (Pseq == _jeuseqADN[i]) {
			_tab_seq_sel[i] = true;
			return;
		}
	}
}

void AAetatJeuSeq::get_seq_selectionnees(JeuSeqBio & jeuseq) {
	unsigned int i;
	for (i=0; i < _tab_seq_sel.size(); i ++) {
		if (_tab_seq_sel[i]) jeuseq.ajouter(*_jeuseqADN[i]);
	}

}

unsigned int AAetatJeuSeq::get_nbseq_selectionnees() const {
	unsigned int i,nbsel(0);
	
	for (i=0; i < _tab_seq_sel.size(); i ++) {
		if (_tab_seq_sel[i]) nbsel++;
	}
	return (nbsel);
}


void AAetatJeuSeq::suppr_seq(const SequenceADN * Pseq) {
	unsigned int i;
	_modif = true;
	
	for (i=0; i < _tab_seq_sel.size(); i ++) {
		if (Pseq == _jeuseqADN[i]) {
			_jeuseqADN.elimine(i);
			_tab_seq_sel.erase(_tab_seq_sel.begin() + i);

			return;
		}
	}
}
