/***************************************************************************
                          aaetatjeuseq.h  -  description
                             -------------------
    begin                : Thu Oct 18 2001
    copyright            : (C) 2001 by Olivier Langella
    email                : Olivier.Langella@pge.cnrs-gif.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef AAETATJEUSEQ_H
#define AAETATJEUSEQ_H

//#include "aamultiadn.h"
#include "sequenceadn.h"
#include "jeuseqbio.h"
/**Stockage de l'tat
des slections en cours, du focus,
du mode de slection...
  *@author Olivier Langella
  */

class AAetatJeuSeq {
public: 
	AAetatJeuSeq(const JeuSeqBio & jeuseq);
	~AAetatJeuSeq();

	void Ajouter_ADN(const JeuSeqBio & jeuseq);
	void reset_selection ();
	void selectionner (const SequenceADN *);
	void get_seq_selectionnees(JeuSeqBio & jeuseq);
	unsigned int get_nbseq_selectionnees() const;
	void suppr_seq(const SequenceADN * Pseq);
	
	JeuSeqADN * get_Pjeuseq() {return(&_jeuseqADN);};
	
private:
	JeuSeqBio * _Pjeuseqbio;
	unsigned int _num_seq_focus; //numro de la squence qui a le focus (pas de focus: 9999)
	
	vector<bool> _tab_seq_sel; //squences slectionnes
	
//	AAmultiADN * _Paffichage;
	JeuSeqADN _jeuseqADN;

	bool _modif;
};

#endif
