/***************************************************************************
                          aamultiadn.cpp  -  description
                             -------------------
    begin                : Thu Oct 18 2001
    copyright            : (C) 2001 by Olivier Langella
    email                : Olivier.Langella@pge.cnrs-gif.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "aa1affichev_adn.h"
#include "aamultiadn.h"

AAmultiADN::AAmultiADN(const JeuSeqBio & jeuseq){

	_Petatjeuseq = new AAetatJeuSeq(jeuseq);
	
	_Pbarredetat =  manage (new AA2barreEtat(this));
	
	_Paff1ADN = manage (new AA1afficheV_ADN(this));

	add( * _Paff1ADN,
                   GTK_SIDE_TOP,
                   GTK_ANCHOR_CENTER,
                   GTK_FILL_X | GTK_FILL_Y | GTK_EXPAND);
	//pack_start(*_Paff1ADN);	
	//pack_start(*_Pbarredetat);	
	//add(*_Paff1ADN);
	//add(*_Pbarredetat);
	add( *_Pbarredetat,
                   GTK_SIDE_BOTTOM,
                   GTK_ANCHOR_SOUTH,
                   GTK_FILL_X);
	
	show();
	
}

AAmultiADN::~AAmultiADN(){
	delete _Petatjeuseq;
}

void AAmultiADN::Ajouter_ADN(const JeuSeqBio & jeuseq) {
	_Petatjeuseq->Ajouter_ADN(jeuseq);
	_Paff1ADN->Ajouter_ADN();
	_Pbarredetat->Ajouter_ADN();
}

JeuSeqADN * AAmultiADN::get_Pjeuseq() const {
	return(_Petatjeuseq->get_Pjeuseq());
	
}

// fonction qui renvoie le nombre total de sequences
int AAmultiADN::getnbseq() const {
	return(get_Pjeuseq()->getnbseq());
	//return(0);
}

void AAmultiADN::get_seq_selectionnee(JeuSeqBio & jeuseq) const {
	_Petatjeuseq->get_seq_selectionnees(jeuseq);
}

void AAmultiADN::suppr_seq_selectionnee() {
	_Paff1ADN->suppr_seq_selectionnee();
}

void AAmultiADN::f_reversecomplement() {
	_Paff1ADN->f_reversecomplement();
}

AAetatJeuSeq * AAmultiADN::get_Petatjeuseq() const {
	return(_Petatjeuseq);
}

void AAmultiADN::select_handler()	{
	_Paff1ADN->select_handler();
	_Pbarredetat->select_handler();
}

void AAmultiADN::toutsel_handler()	{
	_Paff1ADN->toutsel_handler();
	_Pbarredetat->select_handler();
}
