
/***************************************************************************
                          fileseqbio.cpp-  widgets gtk--
                          slection de fichiers de squecnes biologiques
                             -------------------
    begin                : ven avr 14 10:25:55 CEST 2000
    copyright            : (C) 2000 by Olivier Langella CNRS UPR9034
    email                : Olivier.Langella@pge.cnrs-gif.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


// modifi par Kelly Martinez en juillet et aout 2001
#include "fileseqbio.h"
#include "gbioseq.h"


FileSelection_SeqBio::FileSelection_SeqBio(Gbioseq * PGbioseq,const string &title, bool lec, bool ouv)
: FileSelection(title), _PGbioseq(PGbioseq)
{
	//connection des boutons ok et annuler
	get_ok_button()->clicked.connect(slot(_PGbioseq, &Gbioseq::fGetSequences));	
	get_cancel_button()->clicked.connect(slot(this, &FileSelection_SeqBio::fclickAnnuler));
	
	//
	_lire = lec;
	_ouverture = ouv;
	
	show();
}

void FileSelection_SeqBio::fclickAnnuler() {
	destroy(); // doit detruire
}

void FileSelection_SeqBio::fLireFichierSequence(JeuSeqBio& JeuSeqBio,  bool* Pok) {
	*Pok = false;
//cerr << JeuSeqBio.getnbseq() <<endl;
	JeuSeqBio.reset();
//cerr << JeuSeqBio.getnbseq() <<endl;
	
	_fichier.open(get_filename().c_str(), ios::in);
	if (_fichier.is_open() != 0) { //fichier ouvert
		try {
			JeuSeqBio << _fichier;
			*Pok = true;
		}
		catch (JeuSeqBio::Anomalie instance) {
			if (instance.le_pb > 0) {
//cerr << "erreur de lecture... fin " << instance.le_pb <<endl;
					*Pok = false;
				}
		}
		_fichier.close();
	}
}

void FileSelection_SeqBio::fEcrireFichierSequence(JeuSeqBio& JeuSeqBio,  bool* Pok) {
	*Pok = false;
//cerr << JeuSeqBio.getnbseq() <<endl;
//cerr << JeuSeqBio.getnbseq() <<endl;
	ChaineCar nom_fichier(get_filename());
	ChaineCar extension;
	int nbmots(nom_fichier.GetNbMots("."));

	if (nbmots > 1) nom_fichier.GetMot(nbmots, extension, ".");
	
	_fichier.open(nom_fichier.c_str(), ios::out);
	if (_fichier.is_open() != 0) { //fichier ouvert
		try {
			JeuSeqBio._oformat = 1; //FastA
			if (extension == "embl") JeuSeqBio._oformat = 2; //embl
			if (extension == "mega") JeuSeqBio._oformat = 3; //Mega
			if (extension == "gcg") JeuSeqBio._oformat = 4; //GCGMSF
			_fichier << JeuSeqBio;
			*Pok = true;
		}
		catch (JeuSeqBio::Anomalie instance) {
			if (instance.le_pb > 0) {
//cerr << "erreur de lecture... fin " << instance.le_pb <<endl;
					*Pok = false;
				}
		}
		_fichier.close();
	}
}

FileSelection_SeqBio::~FileSelection_SeqBio() {

	_PGbioseq->_Pfichier = 0;	//met le pointeur de Fileseqbio dans Gbioseq  0

};
