/***************************************************************************
                          gbioseq.cpp  -  editeur de sequences biologiques
                             -------------------
    begin                : ven avr 14 10:25:55 CEST 2000
    copyright            : (C) 2000 by Olivier Langella CNRS UPR9034
    email                : Olivier.Langella@pge.cnrs-gif.fr
 ***************************************************************************/

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


// modifi par Kelly Martinez en juillet et aout 2001

#include "gbioseq.h"

void Gbioseq::fGetSequences() {
	bool ok;
	ChaineCar nomfichier;
	string titre;

	if (_Pfichier->lire()) {				//true si on a clique sur le bouton "ouvrir" qui est connecte  fshowlire
		_Pfichier->fLireFichierSequence(_jeuseqBio, &ok);
	//cerr << _JeuSeqBio;
		if (ok) {		//on a mis dans fichier
			_Pfichier->hide();
//			_scrollADN.Ajouter_ADN(_jeuseqBio);
			nomfichier = _Pfichier->get_filename();		//prend le nom du fichier
//cerr << nomfichier.GetNbMots("/") << endl;
			nomfichier.GetMot(nomfichier.GetNbMots("/"),titre,"/");
			if (_Pfichier->ouverture()) {
				_PongletADN->AjouterCour_ADN(_jeuseqBio);
			}
			else {
				_PongletADN->AjouterNouv_ADN(_jeuseqBio,titre);
			}
			_Pfichier->destroy();
			show_all();
//cerr << _scrollADN.get_hscrollbar()->get_adjustment()->get_value();
		}
	}
	else {		// pour l'enregistrement
//		_jeuseqBio = _scrollADN.get_jeuseq();
		_jeuseqBio = *_PongletADN->get_Pjeuseq();
		_Pfichier->fEcrireFichierSequence(_jeuseqBio, &ok);
	//cerr << _JeuSeqBio;
		if (ok) {
			_Pfichier->hide();
		}
	}
}


Gbioseq::Gbioseq(): _jeuseqBio(0) { //_scrollADN(_jeuseqBio) {
//	string titre(_("nouveau"));
	
	_PongletADN = manage(new OngletsGbioseq(this));
	
	set_title ("gBioSeq");
//	_PongletADN->AjouterNouv_ADN(_jeuseqBio, titre);
	_Pmenubarre = manage(new MenuGbioseq(this));
//	_PongletADN = manage(new MenuGbioseq(this));
//	_blirefichier = manage(new Gtk::Button("Lire Squences"));
//	_becrirefichier = manage(new Gtk::Button("Ecrire Squences"));
//	m_button -> add_pixlabel("info.xpm", "cool button");
//	set_title("Pixmap'd buttons!");
//	set_border_width(10);

//	_blirefichier->clicked.connect(bind<char*>(slot(&_fichier,
//			&Gtk_FileSelection_SeqBio::fShowLire),"cool button"));	
//	_blirefichier.clicked.connect(bind<char*>(slot(&_fichier, &Gtk_FileSelection_SeqBio::fShowLire),
//                                            "cool button"));	
//	_blirefichier->clicked.connect(slot(&_fichier, &FileSelection_SeqBio::fShowLire));	
//	_becrirefichier->clicked.connect(slot(&_fichier, &FileSelection_SeqBio::fShowEcrire));	
	set_usize(500, 300);


	_pack.add(*_Pmenubarre, GTK_SIDE_TOP,  GTK_ANCHOR_CENTER, GTK_FILL_X);
//	_pack.add(*_blirefichier, GTK_SIDE_TOP);
//	_pack.add(*_becrirefichier, GTK_SIDE_TOP);
//	_pack.add(_scrollADN, GTK_SIDE_TOP, GTK_ANCHOR_CENTER,
 //                  GTK_FILL_X | GTK_FILL_Y | GTK_EXPAND );
	_pack.add(*_PongletADN, GTK_SIDE_TOP, GTK_ANCHOR_CENTER,
                  GTK_FILL_X | GTK_FILL_Y | GTK_EXPAND );
//	_pack.add_impl(&_ascenceur);

//	_pack.add_impl(&_scrollADN);
//	add(&_scrollADN);
//	add(&_pack);
//	add(*_blirefichier);
//	add(*_becrirefichier);
	add(_pack);

	show_all();
}


void Gbioseq::fShowLire(bool type) {

// 1- creation de la fenetre de selection
// type = true => ouvrir dans courant
	_Pfichier = manage (new FileSelection_SeqBio (this, _("Open a file"), true, type));
}

void Gbioseq::fShowEcrire() {

// 1- creation de la fenetre de selection
	_Pfichier = manage (new FileSelection_SeqBio (this, _("Save into a file"), false));

}

void Gbioseq::fQuitter() {
	Gtk::Main::quit();
}

gint Gbioseq::delete_event_impl(GdkEventAny *) { // (5)
//cerr << "Gbioseq::delete_event_impl(GdkEventAny *) ";
	Gtk::Main::quit();
//	Gtk_Main::instance()->quit();
	return 0;
}


void Gbioseq::f_reversecomplement() {
// faire le reverse complement des squences slectionnes dans l'onglet courant
	_PongletADN->f_reversecomplement();
}

void Gbioseq::copier() {
//copier doit aller chercher la slection de squence
// dans listeBio
// et collecter les squences correspondantes et les
// mettre dans _jeuseqCopie

	_PongletADN->get_seq_selectionnee(_jeuseqCopie);

	//_jeuseqCopie.oFormat(cout,1);
}

void Gbioseq::couper() {
// 1) copier les squences slectionnes
// 2) supprimer les squences slectionnes

	_PongletADN->get_seq_selectionnee(_jeuseqCopie);
	_PongletADN->suppr_seq_selectionnee();

	//_jeuseqCopie.oFormat(cout,1);
}

void Gbioseq::coller() {
	if (_jeuseqCopie.size() > 0) _PongletADN->AjouterCour_ADN(_jeuseqCopie);
//	_PongletADN->get_seq_selectionnee(_jeuseqCopie);
	show_all();

}
