/***************************************************************************
                          gtk_text_adn.cpp  -  widget gtk--
                          pour editer les sequences d'ADN
                             -------------------
    begin                : Tue Dec 12 2000
    copyright            : (C) 2000 by Olivier Langella
    email                : Olivier.Langella@pge.cnrs-gif.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#include "gtk_text_adn.h"



using SigC::slot;
using SigC::bind;




/*
Gdk_Font Gtk_Text_ADN::_police("-Misc-Fixed-Bold-R-Normal--13-120-75-75-C-70-ISO8859-1");
Gdk_Color Gtk_Text_ADN::_couleurNoire("black");
Gdk_Color Gtk_Text_ADN::_couleurFond("white");
Gdk_Color Gtk_Text_ADN::_couleurA("blue");
Gdk_Color Gtk_Text_ADN::_couleurT("green");
Gdk_Color Gtk_Text_ADN::_couleurG("red");
Gdk_Color Gtk_Text_ADN::_couleurC("yellow");
int Gtk_Text_ADN::_tailleVue(60);

*/
Style_Text_ADN::Style_Text_ADN() {
/*:
	_police("-Misc-Fixed-Bold-R-Normal--13-120-75-75-C-70-ISO8859-1"),
	_couleurNoire("black"),
	_couleurFond("white"),
	_couleurA("blue"),
	_couleurT("green"),
	_couleurG("red"),
	_couleurC("yellow"),
	_tailleVue(100) {*/
	Gdk_Font police("-Misc-Fixed-Bold-R-Normal--13-120-75-75-C-70-ISO8859-1");
	//police.set("-Misc-Fixed-Bold-R-Normal--13-120-75-75-C-70-ISO8859-1");
	//
/*	Gdk_Color couleurNoire("black");
	Gdk_Color couleurFond("white");
	Gdk_Color couleurA("red");
	Gdk_Color couleurT("yellow");
//	couleurT.set_rgb(140,140,140);
//	couleurT.set_color(255,140,0);
	Gdk_Color couleurG("green");
	Gdk_Color couleurC("blue");*/

	// couleurs choisies par Coco:
	Gdk_Color couleurNoire("black");
	Gdk_Color couleurFond("white");
	Gdk_Color couleurA("blue");
	Gdk_Color couleurT("green3");
	Gdk_Color couleurG("red");
	Gdk_Color couleurC("orange");
	
	/*
	Gdk_Color couleurNoire("black");
	Gdk_Color couleurFond("white");
	Gdk_Color couleurA("blue");
	Gdk_Color couleurT("green4");
	Gdk_Color couleurG("red");
	Gdk_Color couleurC("orange");*/
	
	_styleAutre.set_background(couleurFond);
	_styleAutre.set_foreground(couleurNoire);
	_styleAutre.set_font(police);

	_styleA = _styleAutre;
	_styleA.set_foreground(couleurA);
	_styleT = _styleAutre;
	_styleT.set_foreground(couleurT);
	_styleG = _styleAutre;
	_styleG.set_foreground(couleurG);
	_styleC = _styleAutre;
	_styleC.set_foreground(couleurC);
	
	_tailleVue = 100;
}

void Gtk_Text_ADN::fcreation() {
//	_tailleVue = 60;
	set_editable(true);
	set_usize(1000, 20);

	set_line_wrap(false);
	set_word_wrap(false);
	_synchroniser = true;
//	_couleurNoire.set("black");
//	_couleurFond.set("white");
//	_couleurA.set("blue");
//	_couleurT.set("green");
//	_couleurG.set("red");
//	_couleurC.set("yellow");
	_offset = 0;

	_PajustementSeq->value_changed.connect(slot(this,&Gtk_Text_ADN::fnouvellePosition));

	this->key_press_event.connect(slot(this, &Gtk_Text_ADN::pour_savoir_pos));	
//	Gtk::ProxySignal2<void,gint,gint,CppObjectType,BaseObjectType,5> move_cursor;

	_chaine.assign(" ");
	_chaine.resize(1);

}

Gtk_Text_ADN::Gtk_Text_ADN(Adjustment * PajustementSeq, Style_Text_ADN* Pstyle, SequenceADN * Poriginal):  _Pstyle(Pstyle){
//:_police("-Misc-Fixed-Bold-R-Normal--13-120-75-75-C-70-ISO8859-1")
	_PajustementSeq = manage(PajustementSeq);
	fcreation();
	
//cerr << "coucou_ADN" << endl;
	_PseqADN = Poriginal;
	_offset = (gint) _PajustementSeq->get_value();
	if (_PajustementSeq->get_upper() <  ((gint) _PseqADN->size() - Pstyle->_tailleVue)) _PajustementSeq->set_upper((gint) _PseqADN->size() - Pstyle->_tailleVue);

//	if (_offset > _PseqADN->size()) _offset = _PseqADN->size();
	set_usize((int) (_Pstyle->_tailleVue * 7.3), 20);
//	set_usize(1381 * 7.3, 20);

//	fEcritSequence();
}

void Gtk_Text_ADN::setSeqADN(SequenceADN * PseqADN) {
	_PseqADN = PseqADN;
//	if (_PajustementSeq->get_upper() < _PseqADN->size()) _PajustementSeq->set_upper(_PseqADN->size());
}


void Gtk_Text_ADN::fResetAfficheSequence() {
//efface et
//met  jour l'affichage avec le contenu de la squence

	Text::delete_text_impl(0, get_length());
	fAfficheSequence();
	
}

void Gtk_Text_ADN::fAfficheSequence() {
//met  jour l'affichage avec le contenu de la squence
	int i;
	int taille(_PseqADN->size());
	int tailleaffichee(get_length());
	int vue(_Pstyle->_tailleVue);
//cerr << "Gtk_Text_ADN::fAfficheSequence()" << endl;

	if (tailleaffichee < vue) {
	//	if (tailleaffichee != 0) set_point(tailleaffichee - 1);
		//if (get_point() > 60) move_to_column(30);
//		for (i= _offset + get_position(); ((i < taille) && (tailleaffichee < vue)) ;i++, tailleaffichee++) {
		for (i= _offset + tailleaffichee; ((i < taille) && ( i < (_offset + vue))) ;i++) {
		//for (i= 0; i < taille ;i++) {
			_chaine[0] = _PseqADN->operator[](i);
			fAfficheLettre();
			//_chaine.assign(_PseqADN->operator[](i));
		}
//		set_point(0);
	}
}

void Gtk_Text_ADN::fAfficheSequenceRecule() {
	gint i;
	gint taille(_PseqADN->size());
	gint tailleaffichee;
	gint vue(_Pstyle->_tailleVue);
//cerr << "Gtk_Text_ADN::fAfficheSequenceRecule()" << endl;

//	cerr << _PseqADN->gettitre() << " coucou" ;
	if (_offset > taille) return;
	tailleaffichee = (gint) Text::get_length();
//cerr << "tailleaffichee " << tailleaffichee << endl;

//	i = (gint) 0;
	
	if (tailleaffichee < vue) {
//		if (tailleaffichee > 0) {
//cerr << "coucou" << endl;
		set_point(0);
//		}
	//	if (tailleaffichee != 0) set_point(tailleaffichee - 1);
		//if (get_point() > 60) move_to_column(30);
//		for (i= _offset + get_position(); ((i < taille) && (tailleaffichee < vue)) ;i++, tailleaffichee++) {
		for (i = _offset; ((tailleaffichee < taille) && (i < taille) && (tailleaffichee < vue)) ; i++, tailleaffichee++) {
//		for (i= _offset; ((tailleaffichee < vue) && (i < taille) && ((_offset + tailleaffichee) < taille)) ;i++, tailleaffichee++) {
		//for (i= 0; i < taille ;i++) {
//cerr << i << " ";
			_chaine[0] = _PseqADN->operator[](i);
			fAfficheLettre();
			//_chaine.assign(_PseqADN->operator[](i));
		}
//cerr << endl ;
//		set_point(0);
	}
	else {
//		cerr << _PseqADN->gettitre() << "coucou" << endl;
	}
}

void Gtk_Text_ADN::fAfficheLettre() {
	//affiche la lettre contenue dans _chaine[0]
	if (_chaine[0] == 'a') _chaine[0] = 'A';
	else if (_chaine[0] == 't') _chaine[0] = 'T';
	else if (_chaine[0] == 'g') _chaine[0] = 'G';
	else if (_chaine[0] == 'c') _chaine[0] = 'C';
	else if (_chaine[0] == ' ') _chaine[0] = '-';
	else if (_chaine[0] == 'n') _chaine[0] = 'N';

	if (_chaine[0] == 'A') Text::insert(_Pstyle->_styleA, _chaine);
	else if (_chaine[0] == 'T') Text::insert(_Pstyle->_styleT, _chaine);
	else if (_chaine[0] == 'G') Text::insert(_Pstyle->_styleG, _chaine);
	else if (_chaine[0] == 'C') Text::insert(_Pstyle->_styleC, _chaine);
	else if (_chaine[0] == 'N') Text::insert(_Pstyle->_styleAutre, _chaine);
	else Text::insert(_Pstyle->_styleAutre, _chaine);
}

void Gtk_Text_ADN::delete_text_impl(gint debut, gint fin) {
// void set_point(guint index);
//  guint get_point() const;
//  guint get_length() const;
	gint pos(get_position());
	
	_Pstyle->_tailleVue += (fin - debut);
	_PseqADN->erase((int) debut, (int) (fin - debut));

	set_point(get_length());
	fAfficheSequence();
	set_point(pos-1);

	Text::delete_text_impl(debut, fin);

//	Text::insert(_Pstyle->_styleAutre, "");
	_Pstyle->_tailleVue -= (fin - debut);
//cerr << get_point() << endl;
//cerr << get_length() << endl;

	changedsize();
}

int  Gtk_Text_ADN::pour_savoir_pos(_GdkEventKey * evenement) {
//cerr << "Gtk_Text_ADN::pour_savoir_pos" << endl;
	gint pos(get_position());
	gint saut(1);
//cerr << "offset " << _offset << endl;
//cerr << evenement->keyval << endl;
//cerr << pos << endl;
	switch (evenement->keyval) {
	case 65363: //droite
		if ((pos == _Pstyle->_tailleVue) &&
				(((gint) _PseqADN->size() - _offset) > _Pstyle->_tailleVue))
			_PajustementSeq->set_value(_offset + saut);
		break;
	case 65361: //gauche
		if ((pos == 0) && (_offset > 0))
			_PajustementSeq->set_value(_offset - saut);
		break;		
	case 65366: //page down
		saut = (int) _PajustementSeq->get_page_increment();
		if ((saut + _offset) < (gint) _PseqADN->size())
			_PajustementSeq->set_value(_offset + saut);
		break;
	case 65365: //page up
		saut = (int) _PajustementSeq->get_page_increment();
		if ((_offset - saut) > 0)
			_PajustementSeq->set_value(_offset - saut);
		break;		
	case 65367: //fin
		saut = _PseqADN->size() - _Pstyle->_tailleVue;
		if (saut > 0)
			_PajustementSeq->set_value(saut);
		break;		
	case 65360: //debut
		if (_offset > 0)
			_PajustementSeq->set_value(0);
		break;
	}
	return(0);
}


void Gtk_Text_ADN::fnouvellePosition() {
//	gint nouvpos(_PajustementSeq->get_value());
//cerr << "Gtk_Text_ADN::fnouvellePosition " << _PajustementSeq->get_value() << endl;

	set_offset((gint) _PajustementSeq->get_value());
	
}

void Gtk_Text_ADN::set_offset(gint offset) {
	gint difference;
//	gint pos;
	
//cerr << "Gtk_Text_ADN::set_offset " << offset << endl;
	if (offset == _offset) {
//cerr << "offset == _offset" << endl;
		return;
	}
	
	if (offset > _offset) {
	//on avance
		if (offset > (gint) _PseqADN->size()) {
	//cerr << "offset > _PseqADN->size()" << endl;
			if (Text::get_length() > 0) Text::delete_text_impl(0, Text::get_length());
			_offset = offset;
			return;
		}
		difference = offset - _offset;
		if (difference < _Pstyle->_tailleVue) {
			Text::delete_text_impl(0, difference);
	//		Text::delete_text_impl(0, difference);
			_offset = offset;
			set_point(get_length());
			fAfficheSequence();
		//	set_point(pos);
		}
		else {
			Text::delete_text_impl(0, Text::get_length());
	//		Text::delete_text_impl(0, difference);
			_offset = offset;
		//	set_point(0);
			fAfficheSequence();
		//	if (pos > get_length()) return; // pos = get_length();
		//	set_point(pos);
		}
	}
	else {
	//on recule
//cerr << "on recule " ;
//cerr << _PseqADN->gettitre() << " coucou " ;
		if (offset > (gint) _PseqADN->size()) {
			_offset = offset;
			return;
		}
		
		difference = _offset - offset;
		gint pos1, pos2;
		if (difference < _Pstyle->_tailleVue) {
//cerr << "1 " << difference << " " << _Pstyle->_tailleVue - difference << endl;

			pos1 = _Pstyle->_tailleVue - difference;
			pos2 =  _Pstyle->_tailleVue;

			if (pos1 < (gint) Text::get_length()) {
				if (pos2 < (gint) Text::get_length()) Text::delete_text_impl(pos1, pos2);
				else Text::delete_text_impl(pos1, Text::get_length());
			}
//			Text::delete_text_impl(_Pstyle->_tailleVue - difference, _Pstyle->_tailleVue);
//			Text::delete_text_impl(0, difference);
			_offset = offset;
//			set_point(0);
			fAfficheSequenceRecule();
//cerr << pos << endl;	
		//	if (pos > get_length()) return;// pos = 0;
			//set_point(pos);
		}
		else {
//cerr << "2 " << endl;
			pos1 = 0;
			pos2 =  Text::get_length();
			if (pos1 < (gint) Text::get_length()) {
				if (pos2 < (gint) Text::get_length()) Text::delete_text_impl(pos1, pos2);
				else Text::delete_text_impl(pos1, Text::get_length());
			}
			_offset = offset;
	//		set_point(0);
			fAfficheSequenceRecule();
			//if (pos > get_length()) return;// pos = 0;
			//set_point(pos);
		}
	}
	
}

void Gtk_Text_ADN::insert_text_impl(const gchar* Pchar, gint taille, gint* Pposition) {
	int i;
//cerr << "Gtk_Text_ADN::insert_text_impl" << endl;
//cerr << get_point() << endl;
	//if (get_point() > 60) move_to_column(30);
	for (i=0; i < taille ;i++) {
		_chaine[0] = *(Pchar + i);
		if (_chaine[0] == 'a') _chaine[0] = 'A';
		else if (_chaine[0] == 't') _chaine[0] = 'T';
		else if (_chaine[0] == 'g') _chaine[0] = 'G';
		else if (_chaine[0] == 'c') _chaine[0] = 'C';
		else if (_chaine[0] == ' ') _chaine[0] = '-';
		else if (_chaine[0] == 'n') _chaine[0] = 'N';

		if (_chaine[0] == 'A') {
//			insert(_Pstyle->_police, _Pstyle->_couleurA , _Pstyle->_couleurFond, _chaine, 1);
			insert(_Pstyle->_styleA, _chaine);
			_PseqADN->insert(*Pposition + _offset,_chaine,0,1);
//cerr << *_PseqADN << endl;
		}
		else if (_chaine[0] == 'T') {
//			insert(_Pstyle->_police, _Pstyle->_couleurT, _Pstyle->_couleurFond, _chaine, 1);
			insert(_Pstyle->_styleT, _chaine);
			_PseqADN->insert(*Pposition + _offset,_chaine,0,1);
		}
		else if (_chaine[0] == 'G') {
//			insert(_Pstyle->_police, _Pstyle->_couleurG, _Pstyle->_couleurFond, _chaine, 1);
			insert(_Pstyle->_styleG, _chaine);
			_PseqADN->insert(*Pposition + _offset,_chaine,0,1);
		}
		else if (_chaine[0] == 'C')  {
//			insert(_Pstyle->_police, _Pstyle->_couleurC, _Pstyle->_couleurFond, _chaine, 1);
			insert(_Pstyle->_styleC, _chaine);
			_PseqADN->insert(*Pposition + _offset,_chaine,0,1);
		}
		else if (_chaine[0] == '#')  {
//			insert(_Pstyle->_police, _Pstyle->_couleurNoire, _Pstyle->_couleurFond, _chaine, 1);
			insert(_Pstyle->_styleAutre, _chaine);
			_PseqADN->insert(*Pposition + _offset,_chaine,0,1);
		}
		else if (_chaine[0] == '-')  {
//			insert(_Pstyle->_police, _Pstyle->_couleurNoire, _Pstyle->_couleurFond, _chaine, 1);
			insert(_Pstyle->_styleAutre, _chaine);
			_PseqADN->insert(*Pposition + _offset,_chaine,0,1);
		}
		else if (_chaine[0] == 'N')  {
//			insert(_Pstyle->_police, _Pstyle->_couleurNoire, _Pstyle->_couleurFond, _chaine, 1);
			insert(_Pstyle->_styleAutre, _chaine);
			_PseqADN->insert(*Pposition + _offset,_chaine,0,1);
		}
		else {
//			insert(_Pstyle->_police, _Pstyle->_couleurNoire, _Pstyle->_couleurFond, _chaine, 0);
		}
	}
	
	changedsize();

}


void Gtk_Text_ADN::changedsize() {
	// pour prvenir d'un changement de taille
	// appel par toutes les fonctions qui changent la taille (delete, insert)


	//change la taille max du scrolling horizontal:
	// (dans le cas d'un insert)
	if (_PajustementSeq->get_upper() < (_PseqADN->size() - _Pstyle->_tailleVue)) _PajustementSeq->set_upper(_PseqADN->size() - _Pstyle->_tailleVue);
	// (dans le cas d'une suppression, il faut comparer avec les autres
	// sequences et ne modifier que si c'est la plus grande qui est modifie)
	// => retour  l'objet conteneur

}

bool Gtk_Text_ADN::est_la_sequence(const SequenceBio * Pseq) const {

	if (_PseqADN == Pseq) return (true);
	else return (false);
}
