/***************************************************************************
                          gtk_text_adn.h  -   widget gtk--
                          pour editer les sequences d'ADN
                             -------------------
    begin                : Tue Dec 12 2000
    copyright            : (C) 2000 by Olivier Langella
    email                : Olivier.Langella@pge.cnrs-gif.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GTK_TEXT_ADN_H
#define GTK_TEXT_ADN_H


#include "internat.h"
#include "sequenceadn.h"
#include <gtk--/widget.h>
#include <gtk--/adjustment.h>
#include <gtk--/text.h>
using namespace Gtk;


class Style_Text_ADN {

public:
	Style_Text_ADN();
	~Style_Text_ADN() {};
	
/*	Gdk_Font _police;

	Gdk_Color _couleurNoire;
	Gdk_Color _couleurFond;
	Gdk_Color _couleurA;
	Gdk_Color _couleurT;
	Gdk_Color _couleurG;
	Gdk_Color _couleurC;
*/
	Gtk::Text_Helpers::Context _styleA;
	Gtk::Text_Helpers::Context _styleT;
	Gtk::Text_Helpers::Context _styleG;
	Gtk::Text_Helpers::Context _styleC;
	Gtk::Text_Helpers::Context _styleAutre;
	
	gint _tailleVue;
private:
};

class Gtk_Text_ADN: public Gtk::Text {

public:
//	Gtk_Text_ADN(Style_Text_ADN*);
	Gtk_Text_ADN(Gtk::Adjustment *, Style_Text_ADN*,SequenceADN *);
	~Gtk_Text_ADN() {};

	
	void setSeqADN(SequenceADN *);
	void fResetAfficheSequence();
	void fAfficheSequence();

	Gtk::Adjustment * _PajustementSeq;

	void set_offset(gint offset);
	
	bool est_la_sequence(const SequenceBio *) const;
	
protected:

	void fnouvellePosition();

	void changedsize();

	int pour_savoir_pos(_GdkEventKey * evenement);

	virtual void insert_text_impl(const gchar*, gint, gint*);
	virtual void delete_text_impl(gint, gint);
	SequenceADN* _PseqADN;

private:
	void fAfficheSequenceRecule();
	void fAfficheLettre();
	void fcreation();

	Style_Text_ADN* _Pstyle;
	
	gint _offset;
	bool _synchroniser;
	
	string _chaine;

};

#endif

