/***************************************************************************
                          jeuseqbio.cpp  -  description
                             -------------------
    begin                : Tue Dec 12 2000
    copyright            : (C) 2000 by Olivier Langella
    email                : Olivier.Langella@pge.cnrs-gif.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// a declarer avec les MFCs:
//#include "stdafx.h"


#include "jeuseqbio.h"

int JeuSeqBio::_oformat = 1; //Format de sortie: par dfaut

JeuSeqBio& JeuSeqBio::operator<<(istream& ientree) {
	JeuSeqBio& lesseq(*this);
	//fichier au format  dterminer
	int nbformatmax(6);
	int i(0);
	bool formatok(false);

	if (JeuSeqBio::iVerifFormat(ientree) == false) {
		throw JeuSeqBio::Anomalie(2);
	}

	JeuSeqBio newseq(0);

	do {
		try {
			newseq.ifichier(ientree, i);
//			AfxMessageBox("coucou2",MB_OK);
			formatok = true;

			ientree.clear();
			ientree.seekg(0);

		}
		catch (JeuSeqBio::Anomalie instance) {
			if (instance.le_pb > 0) {
//			AfxMessageBox("coucou3",MB_OK);
				formatok = false;
			}
		}
		i++;
	} while ((formatok == false) && (i < nbformatmax));

	if (formatok==false) {
		throw JeuSeqBio::Anomalie(2);
	}

	lesseq = lesseq + newseq;
		/*	itoa(i, buffer , 10);
			titre.assign("seq");
			titre += buffer;
			lesseq[i].SetTitre(titre);*/

	return (*this);
}

ostream&  operator<<(ostream& sortie, const JeuSeqBio& lesseq) {
	//1= FastA
	//2= EMBL
	//3= Mega
	//4= GcgMsf

	lesseq.oFormat(sortie, lesseq._oformat);
	return(sortie);
}


SequenceADN& SequenceADN::fcomplement(){
	// partir du brin matrice 5' 3'
	//fourni le brin complmentaire dans le sens 5' 3'

	int taille(size());
	int i;
	string copie(*this);

	for (i = 0; i < taille; i++) {
		switch (operator[](i)) {
		case 'A':
			copie[(taille-1) - i] = 'T';
			break;
		case 'T':
			copie[(taille-1) - i] = 'A';
			break;
		case 'G':
			copie[(taille-1) - i] = 'C';
			break;
		case 'C':
			copie[(taille-1) - i] = 'G';
			break;
		default:
			copie[(taille-1) - i] = operator[](i);
			break;
		}
	}

	assign(copie);

	_complementaire = !(_complementaire);

	return(*this);
}

SequenceBio* JeuSeqBio::newSequenceBio() {
	return(new SequenceBio);
}

SequenceBio* JeuSeqBio::newSequenceBio(const SequenceBio & seq) {
	return(new SequenceBio(seq));
}

SequenceADN* JeuSeqADN::newSequenceBio() {
	return(new SequenceADN);
}

JeuSeqBio::JeuSeqBio(const JeuSeqBio& original) {
	//constructeur de copie
	//nombre de squences
	unsigned int i;

	if (_vectseq.size() != 0) reset();

	_titre = original._titre;

	for (i=0 ; i < original._vectseq.size(); i++) {
		//nouvelle squence
		_vectseq.push_back(newSequenceBio(*(original._vectseq[i])));
//		Pseq = newSequenceBio();
//		_vectseq.push_back(Pseq);
//		*(_vectseq[_vectseq.size()-1]) = *(original._vectseq[i]);
	}
}

const JeuSeqBio& JeuSeqBio::operator= (const JeuSeqBio &rval){

	unsigned int i;

	if (&rval != this) {
		_titre = rval._titre;
		if (_vectseq.size() != 0) reset();

		for (i=0 ; i < rval._vectseq.size(); i++) {
			//nouvelle squence
			_vectseq.push_back(newSequenceBio());
			*_vectseq[_vectseq.size()-1] = *(rval._vectseq[i]);
		}
	}
	return (*this);
}

void JeuSeqBio::reset() {
	unsigned int i;
	for (i=0; i < _vectseq.size();i++) {
		delete _vectseq[i];
	}
	_vectseq.resize(0);
}

JeuSeqBio& JeuSeqBio::operator+=(const JeuSeqBio &seqrvalue) {
	//surcharge du +=
	//nombre de squences
	unsigned int j;

	for (j=0 ; j < seqrvalue._vectseq.size(); j++) {
		_vectseq.push_back(newSequenceBio());
		*(_vectseq.back()) = *(seqrvalue._vectseq[j]);
		if (_vectseq.back()->_titre == "") {
			_vectseq.back()->_titre = "seq_";
			_vectseq.back()->_titre.AjEntier(_vectseq.size());
		}
	}

	return (*this);
}

void JeuSeqBio::ajouter(const SequenceBio & seq) {
	_vectseq.push_back(newSequenceBio(seq));
}


JeuSeqBio JeuSeqBio::operator+(const JeuSeqBio &seqrvalue) {
	//surcharge du +
	//nombre de squences
	unsigned int i,j;
//	char buffer[10];

	JeuSeqBio Resultat(_vectseq.size() + seqrvalue._vectseq.size());

	Resultat._titre = _titre;

	for (i=0 ; i < _vectseq.size(); i++) {
//		Resultat._vectseq.push_back(new SequenceBio());
		*(Resultat._vectseq[i]) = *(_vectseq[i]);
	}
	for (j=0 ; j < seqrvalue._vectseq.size(); j++) {
//		Resultat._vectseq.push_back(new SequenceBio());
		*(Resultat._vectseq[i]) = *(seqrvalue._vectseq[j]);
		if (Resultat._vectseq[i]->_titre == "") {
			Resultat._vectseq[i]->_titre = "seq_";
			Resultat._vectseq[i]->_titre.AjEntier(i+1);
//			itoa(i+1, buffer , 10);
//			Resultat._vectseq[i]->_titre += buffer;
		}
		i++;
	}

	return Resultat;
}

JeuSeqBio JeuSeqBio::operator+(const SequenceBio &seqrvalue) {
	//surcharge du +
	//nombre de squences
	int i,j;
	JeuSeqBio Resultat(_vectseq.size() + 1);

	Resultat._titre = _titre;

	j = _vectseq.size() - 1;
	for (i=0 ; i < j; i++) {
//		Resultat._vectseq.push_back(new SequenceBio());
		*(Resultat._vectseq[i]) = *(_vectseq[i]);
	}
	*(Resultat._vectseq[j]) = seqrvalue;

	return (Resultat);
}

JeuSeqBio::JeuSeqBio(istream & entree){
	//fichier au format  dterminer
	int nbformatmax(6);
	int i(1);
	bool formatok(false);

	do {
		try {

			ifichier(entree, i);
			formatok = true;

			entree.clear();
			entree.seekg(0);

		}
		catch (Anomalie instance) {
			if (instance.le_pb > 0) {
				formatok = false;
			}
		}
		i++;
	} while ((formatok == false) && (i < nbformatmax));

	if (formatok==false) {
		throw Anomalie(2);
	}

}

JeuSeqBio::JeuSeqBio(unsigned int nseq){
	//nombre de squences
	unsigned int i;

//cerr << "JeuSeqBio::JeuSeqBio" << endl;	
	_vectseq.resize(0);
//cerr << "JeuSeqBio::JeuSeqBio" << endl;	
	if (nseq == 0) return;
//cerr << "JeuSeqBio::JeuSeqBio" << endl;	
	_vectseq.reserve(nseq);
	for (i=0 ; i < nseq; i++) {
		//nouvelle squence
		_vectseq.push_back(newSequenceBio());
	}
}

JeuSeqADN::JeuSeqADN():JeuSeqBio(){
}

JeuSeqADN::JeuSeqADN(int nseq):JeuSeqBio(nseq){
}

JeuSeqADN::JeuSeqADN(const JeuSeqBio & original):JeuSeqBio(original){
}
JeuSeqADN::JeuSeqADN(const JeuSeqADN & original):JeuSeqBio(original){
}

void JeuSeqBio::ifichier(istream & fichier, int nbformat){
	//fichier au format dtermin
	unsigned int i;
	// nbformat = 1 => FastA;
	// 2 => EMBL;
	// 3 => Mega;
	// 4 => GCG;
	// 0 => Raw, format brut;

	switch (nbformat) {
	case 1: // => FastA;
		iFastA(fichier);
		break;
	case 2: // => EMBL;
		iEMBL(fichier);
		break;
	case 3: // => Mega;
		iMega(fichier);
		break;
	case 4: // => GCG;
		iGCG(fichier);
		break;
	case 5: // => Genbank;
		iGenbank(fichier);
		break;
	case 0: // => RAW;
		iRaw(fichier);
		break;
	default:
		throw Anomalie(2);
		break;
	} // fin du switch

//	string majus;
	for (i=0 ; i < _vectseq.size(); i++) {
		_vectseq[i]->fmajus();
		_vectseq[i]->fsupprchiffres();
	}

}

JeuSeqBio::~JeuSeqBio(){
	unsigned int i;

	for (i=0; i < _vectseq.size();i++){
		delete _vectseq[i];
	}
}

void JeuSeqBio::oFormat(ostream &sortie, int nbformat) const {

	if (_vectseq.empty()) throw Anomalie(12);
	if (nbformat == 0) throw Anomalie(13);

	switch (nbformat) {
	case 1:// FastA
		oFastA(sortie);
		break;
	case 2:// EMBL
	//	throw Anomalie(11);
		oEMBL(sortie);
		break;
	case 3:// Mega
		oMega(sortie);
		break;
	case 4:// GcgMsf
		oGcgMsf(sortie);
		break;

	default:
		throw Anomalie(11);
		break;
	}
}


void JeuSeqBio::oFastA(ostream &sortie) const {
	unsigned int i;

//	fGCGchecksum();

	for (i=0; i < _vectseq.size();i++){
//		sortie <<">" << _vectseq[i]->_titre << "  " << dec <<  _vectseq[i]->_seq.size() << " bases  " << hex <<  _vectseq[i]->_checksum << " checksum." << endl;
		sortie <<">" << _vectseq[i]->_titre << "  " <<  _vectseq[i]->size() << " bases  " << endl;
		sortie << *_vectseq[i] << endl;
	}
	
//	sortie << ends;

}

void JeuSeqBio::oEMBL(ostream &sortie) const {
	unsigned int i,j;
	string blanc("    ");
	string ecrit;

	for (i=0; i < _vectseq.size();i++){
		sortie << "ID   " << _vectseq[i]->_titre << endl;
		sortie << "DE   " << _vectseq[i]->_titre << " " <<_vectseq[i]->size() << " bases, tfseq." << endl;
		sortie << "SQ             " <<_vectseq[i]->size() << "BP" << endl;
		
		ecrit.assign(*_vectseq[i]);
		j=0;
		while (j < ecrit.size()) {
			ecrit.insert(j," ");
			j += 11;
		}
		j=0;
		while (j < ecrit.size()) {
			sortie << blanc << ecrit.substr(j,66) << endl;
			j += 66;
		}

		sortie << "//" << endl;
	}
	
//	sortie << ends;

}

void JeuSeqBio::oMega(	ostream &sortie) const {

	unsigned int i, j, taille, ntour;
	int pos, tbloc(101);
	string blanc("                                   ");
	string ecrit(blanc);
	vector<SequenceBio*> seqcopie;

	taille = _vectseq[0]->size();
//	AfxMessageBox("Les squences doivent avoir la mme taille...",MB_OK);

	for (i=1; i < _vectseq.size();i++){
//		if (taille != _vectseq[i]->_seq.size()) throw Anomalie(10) ;
		if (taille < _vectseq[i]->size()) taille = _vectseq[i]->size();
	}	

// Il faut mettre toutes les squences  la mme taille
// recopie des squences:
	for (i=0 ; i < _vectseq.size(); i++) {
		//nouvelle squence
		seqcopie.push_back(new SequenceBio(*(_vectseq[i])));
		for (j=seqcopie[i]->size(); j < taille;j++) {
			*seqcopie[i] += "-";
		}
	}


	sortie << "#MEGA" << endl;
	sortie << "TITLE  exported by Tfseq" << endl << endl;

	ntour = (taille - 1) / tbloc + 1;
	for (j = 0; j < ntour; j++) {
		pos = j * tbloc;
		for (i=0; i < seqcopie.size();i++){
			ecrit.assign(blanc);
			sortie <<"#" << ecrit.replace(0,seqcopie[i]->_titre.size(),seqcopie[i]->_titre);
			sortie << seqcopie[i]->substr(pos, tbloc) << endl;
		}
		sortie << endl;
	}
//	sortie << ends;

	for (i=0 ; i < _vectseq.size(); i++) {
		delete seqcopie[i];
	}



}
void JeuSeqBio::oGcgMsf(ostream &sortie) const {
// Attention, avec cette procdure on obtient des fichiers lisibles
	//par Genedoc, mais ces fichiers n'on pas vraiment le format GCG MSF
	// othodoxe!!!
	unsigned int i, j, taille;
	int ntour, pos, tbloc(50), tailletitre(10);
//	char chiffre[7];
	string blanc("               ");
	string ecrit(blanc);
	ChaineCar temp;
	vector<SequenceBio*> seqcopie;
//	SequenceBio* Pseq;

	taille = _vectseq[0]->size();

	for (i=1; i < _vectseq.size();i++){
		if (taille < _vectseq[i]->size()) taille = _vectseq[i]->size();
	}
// Il faut mettre toutes les squences  la mme taille
// recopie des squences:
	for (i=0 ; i < _vectseq.size(); i++) {
		//nouvelle squence
		seqcopie.push_back(new SequenceBio(*(_vectseq[i])));
		for (j=seqcopie[i]->size(); j < taille;j++) {
			*seqcopie[i] += "-";
		}
	}


	sortie << "GCG MSF file exported by Tfseq" << endl;
	sortie << " MSF: " << taille << " Check: 3385 .." << endl <<endl;

	temp.assign("  Len: ");
	temp.AjEntier(taille);
	temp += "  Check: 3180  Weight:   1.00";
	for (i=0; i < _vectseq.size();i++){
		ecrit.assign(blanc);
		sortie <<" Name: " << ecrit.replace(0,tailletitre,_vectseq[i]->_titre.substr(0,tailletitre));
		sortie << temp << endl;
	}
	sortie << endl << "//" << endl << endl;

	ntour = (taille - 1) / tbloc + 1;
	blanc.assign("       ");
	for (int k = 0; k < ntour; k++) {
		pos = k * tbloc;
		sortie << blanc << pos+1 << endl;
		for (i=0; i < _vectseq.size();i++){
			ecrit.assign(seqcopie[i]->substr(pos, tbloc));
			j=10;
			while (j < ecrit.size()) {
				ecrit.insert(j," ");
				j += 11;
			}

			sortie <<_vectseq[i]->_titre.substr(0, tailletitre) << "  " << ecrit << endl;
		//	sortie << blanc << ecrit << endl;
		}
		sortie << endl;
	}
//	sortie << ends;
	for (i=0 ; i < _vectseq.size(); i++) {
		delete seqcopie[i];
	}

}

void JeuSeqBio::iFastA(istream & fichier){
	//fichier au format dtermin: FastA
//Compatible Mac

	// 1 => FastA;
//	int i(0);
//	char mot[100];
//	char car;
	ChaineCar lecture;

	fichier.seekg(0);
	fichier.clear();
		//dtection de format
//	fichier >> mot;
	lecture.GetLigneFlot(fichier);
//cerr << lecture;
	if (lecture[0] != '>') throw Anomalie(3);
	do {
//cerr << lecture;
		if (lecture.size() > 0) {
			if (lecture[0] != '>') {
				//stockage de la squence
				*_vectseq.back() += lecture;
			}
			else {
				//nouvelle squence
				_vectseq.push_back(new SequenceBio());
				lecture.GetMot(1,lecture);
				_vectseq[_vectseq.size()-1]->_titre.assign(lecture.substr(1, lecture.size()-1));
			}
		}
		lecture.GetLigneFlot(fichier);
	} while (fichier.eof() == 0);
	*_vectseq.back() += lecture;
	
	/*if (fichier.eof() != 0) {
		*_vectseq[_vectseq.size()-1] += lecture.substr(0,lecture.size() - 1);
	}*/

}

bool JeuSeqBio::iVerifFormat(istream & fichier) {
	//fichier a verifier
	char car;
	bool result(false);
	int i(0);
//cerr << "iverifformat" << endl;

	fichier.seekg(0);
	fichier.clear();
	car = fichier.peek();
//cerr << (int)car << endl;
	while (((car > 31) && (car < 125)) || ((car > 7) && (car < 20)) || (car == ' ')) {
		if (fichier.eof()) break;
		fichier.get(car);
		car = fichier.peek();
//cerr << (int)car << endl;

		if (i == 10) break;
		i++;
	}

	if (i == 10) {result = true;
//cerr << "iverifformat vrai" << endl;
	}
	else {
//cerr << "iverifformat faux" << (int)car << endl;
	}
	return (result);
}


void JeuSeqBio::iRaw(istream & fichier){
//Compatible Mac
	//fichier au format brut (squence seule)
	// en travaux
	// 0 => Raw;
//	int i(0);
	char car;
	string lecture("");

	fichier.seekg(0);
	fichier.clear();
	car = fichier.peek();
//cerr << (int) car << " ";
	if ((fichier.eof())||(car <= 64)||(car >= 125)) throw Anomalie(3);
//cerr << (int) car << " coucou ";
	while (((!fichier.eof())&&(car > 64)&&(car < 125))||((car > 7) && (car < 15))) {
		if ((car == 'A') || (car == 'T') || (car == 'G') || (car == 'C') || (car == 'a')|| (car == 't')|| (car == 'g')|| (car == 'c')|| (car == 'N')|| (car == 'n')|| (car == '_')|| (car == '-')){

			//stockage de la squence
			lecture += car;
		}
		else {
			if ((car > 7) && (car < 15)) { //retour chariot  passer
			}
			else {
				throw Anomalie(3);
			}
		}
		fichier.get(car);
		car = fichier.peek();
//cerr << (int) car << " ";
	}

//cerr << (int) car << "  coucou 2";
	if (car == ' ') throw Anomalie(3);
	if (lecture == "") throw Anomalie(3);
			//nouvelle squence
	_vectseq.push_back(new SequenceBio());
	_vectseq[_vectseq.size()-1]->assign(lecture);
	_vectseq[_vectseq.size()-1]->_titre.assign("");

}

void JeuSeqBio::iEMBL(istream & fichier){
	//fichier au format dtermin: EMBL
//Compatible Mac
	// 2=> EMBL;

//	int i(0);
	char car;
//	char mot[100];
	string lecture;

	fichier.seekg(0);
	fichier.clear();
		//dtection de format
	fichier >> lecture;
			
	if (lecture != "ID") throw Anomalie(3);

	fichier.seekg(0);

	lecture.assign("");
	fichier >> lecture;
	do {
		if (lecture == "SQ") {
			//stockage de la squence
			fichier.get(car);//bouffe une ligne
			while (car > 30) fichier.get(car);//bouffe une ligne
		//	fichier.getline(mot, 100, '\n'); //bouffe une ligne

			fichier >> lecture;
			while ((lecture != "//")&&(fichier.eof()==0)){
				*_vectseq[_vectseq.size()-1] += lecture;

				fichier >> lecture;
			}
		}
		else {
			//nouvelle squence
			if (lecture == "ID") {
				fichier >> lecture;

				_vectseq.push_back(new SequenceBio());
				_vectseq[_vectseq.size()-1]->_titre.assign(lecture);
				fichier.get(car);//bouffe une ligne
				while (car > 30) fichier.get(car);//bouffe une ligne
	//			fichier.getline(mot, 100, '\n'); //bouffe une ligne
			}
		}

		lecture.assign("");
		fichier >> lecture;
	} while (fichier.eof() == 0);

}

void JeuSeqBio::iGenbank(istream & fichier){
	//fichier au format dtermin: Genbank

	// 5=> Genbank;

	// pas termin
//	int i(0);
	char car;
	string lecture;

	fichier.seekg(0);
	fichier.clear();
		//dtection de format
	fichier >> lecture;
//			AfxMessageBox("coucou",MB_OK);
			
	if (lecture != "LOCUS") throw Anomalie(3);

	fichier.seekg(0);

	lecture.assign("");
	fichier >> lecture;
	do {
		if (lecture == "ORIGIN") {
			//stockage de la squence
			fichier.get(car);//bouffe une ligne
			while (car > 30) fichier.get(car);//bouffe une ligne
//			fichier.getline(mot, 100, '\n'); //bouffe une ligne

			fichier >> lecture;
			while ((lecture != "//")&&(fichier.eof()==0)){
				*_vectseq[_vectseq.size()-1] += lecture;

				fichier >> lecture;
			}
		}
		else {
			//nouvelle squence
			if (lecture == "LOCUS"){
				fichier >> lecture;

				_vectseq.push_back(new SequenceBio());
				_vectseq[_vectseq.size()-1]->_titre.assign(lecture);

				fichier.get(car);//bouffe une ligne
				while (car > 30) fichier.get(car);//bouffe une ligne
		//		fichier.getline(mot, 100, '\n'); //bouffe une ligne
				fichier >> lecture;

				if (lecture != "DEFINITION") throw Anomalie(3);
				fichier.get(car);//bouffe une ligne
				while (car > 30) fichier.get(car);//bouffe une ligne
			}

		}

		lecture.assign("");
		fichier >> lecture;
	} while (fichier.eof() == 0);

}

void JeuSeqBio::iGCG(istream & fichier){
	//fichier au format dtermin: GCG
//compatible MAC
	// 4=> GCG;

	// pas termin
	int pos(0);
//	char mot[100];
	char car;
	string lecture, precedent;

	fichier.seekg(0);
	fichier.clear();
		//dtection de format
	fichier >> lecture;
			
	if (lecture != "DEFINITION") throw Anomalie(3);

//	fichier.seekg(pos);

	lecture.assign("");
//	fichier >> lecture;
	do {
			//nouvelle squence
		fichier.seekg(pos);
		fichier >> lecture;
			if (lecture == "DEFINITION") {
				_vectseq.push_back(new SequenceBio());

				while ((lecture != "Length:") && (fichier.good())){
					precedent = lecture;
					fichier >> lecture;
				}
				_vectseq[_vectseq.size()-1]->_titre.assign(precedent);

				fichier.get(car);//bouffe une ligne
				while (car > 30) fichier.get(car);//bouffe une ligne
			//	fichier.getline(mot, 100, '\n'); //bouffe une ligne

				pos = fichier.tellg();
				fichier >> lecture;
				while ((lecture != "DEFINITION") && (fichier.eof() == 0)){
					*_vectseq[_vectseq.size()-1] += lecture;

					pos = fichier.tellg();
					fichier >> lecture;
				}
				if (fichier.eof() != 0) {
					*_vectseq[_vectseq.size()-1] += lecture.substr(0,lecture.size() - 1);
				}
			}
	
//		lecture.assign("");
//		fichier >> lecture;
	} while ((fichier.eof() != 0)&&(lecture != ""));

}

void JeuSeqBio::iMega(istream & fichier){
	//fichier au format dtermin: Mega
// compatible mac
	// 3 => Mega;

	// pas termin
	int i(0), nbseq(0);
	long debut;
	char mot[150];
	char car;
	string lecture;

	fichier.seekg(0);
	fichier.clear();
		//dtection de format
	fichier >> lecture;
			
	if (lecture != "#MEGA") throw Anomalie(3);

//	fichier.seekg(0);

	fichier >> lecture;
	fichier >> _titre;


	do {
		debut = fichier.tellg();
		fichier.get(car);
		if (fichier.eof() != 0) throw Anomalie(1);
	} while (car != '#');
	fichier >> lecture;
//	fichier >> mot;
	while (car == '#'){
		nbseq ++;
		_vectseq.push_back(new SequenceBio());
		_vectseq[_vectseq.size()-1]->_titre.assign(lecture);

		fichier.get(car);//bouffe une ligne
		while (car > 30) {
			fichier.get(car);
//			fichier.peek(car)
		}
		car = fichier.peek();
		if (car != '#') fichier.get(car);
		fichier.get(car);
		fichier >> lecture;
	}

	fichier.clear();

	fichier.seekg(debut);
	do {
		for (i = 0; i<nbseq; i++) {
			fichier >> mot;
			fichier >> lecture;
			*_vectseq[i] += lecture;
		}

	} while (fichier.eof() == 0);

}

void JeuSeqBio::fGCGchecksum() const
/* GCGchecksum */
{
//	register long  i, check = 0, count = 0;
	unsigned long  i, jseq, check, count, checktotal(0);
	int car;
//	_checktotal = 0;

	for (jseq = 0; jseq < _vectseq.size(); jseq++) {
		check = 0;
		count = 0;

		for (i = 0; i < _vectseq[jseq]->size(); i++) {
			count++;
			car = _vectseq[jseq]->operator[](i);
			check += count * (unsigned long) (((car > 96)&&(car < 124)) ? car = car - 32: car );
			if (count == 57) count = 0;
		}
		check %= 10000;
		checktotal += check;
		checktotal %= 10000;

		_vectseq[jseq]->_checksum = check;
	}

}

void JeuSeqBio::fnettoie(const string & mot) {

	unsigned int i;

	for (i = 0; i < _vectseq.size(); i++) {
		_vectseq[i]->fnettoie(mot);
	}
}

void JeuSeqBio::SwapSeq(unsigned int a, unsigned int b) {
	if (a == b) {return;}
	if ((a <0) || (a >= _vectseq.size())) {throw Anomalie(14);}
	SequenceBio* Pseqswap;
	Pseqswap = _vectseq[a];
	_vectseq[a] = _vectseq[b];
	_vectseq[b] = Pseqswap;
}
