/***************************************************************************
                          menu.cpp  -  barre de menu
                          necessaire a gbioseq
                             -------------------
    begin                : ven 2 mai 10:25:55 CEST 2000
    copyright            : (C) 2000 by Olivier Langella CNRS UPR9034
    email                : Olivier.Langella@pge.cnrs-gif.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 // modifi par Kelly Martinez en juillet et aout 2001

#include "menu.h"
#include "gbioseq.h"

//using SigC::slot;
using SigC::bind;

void MenuGbioseq::fOuvrir() {
//	cout << "coucou";
	_Pappli->fGetSequences();
}

void MenuGbioseq::fEnregistrer() {
//	cout << "coucou";
	
	_Pappli->fGetSequences();
}

void MenuGbioseq::fApropos() {
	AproposGbioseq * Papropos;

	Papropos = manage(new AproposGbioseq);
	Papropos->show();
}


MenuGbioseq::MenuGbioseq(Gbioseq * Pappli): _Pappli(Pappli) {
//	_blirefichier->clicked.connect(bind<int>(slot(&_fichier, &FileSelection_SeqBio::fShowLire), 6));	
//	_becrirefichier->clicked.connect(slot(&_fichier, &FileSelection_SeqBio::fShowEcrire));	

	{
		using namespace Menu_Helpers;

		// Create the file menu
		Gtk::Menu *   menu_fichier (SigC::manage<Gtk::Menu>( new Gtk::Menu));
 		MenuList& list_fichier    = menu_fichier->items();

 		// Connecting non-default callback, getting the element's widget
		list_fichier.push_back(MenuElem(_("new")));
		list_fichier.back()->activate.connect(bind<char*>(slot( this->_Pappli->_PongletADN, &OngletsGbioseq::NouvelOnglet),_("nouveau")));


//		list_fichier.back()->activate.connect(slot(::fOuvrir));
		//list_fichier.back()->activate.connect(bind(slot(::fOuvrir), 123));
                    // ^^^^^^^^^^^^^^^^


		// Usage of widget functions on menuitems
		list_fichier.push_back(MenuElem(_("_Open")));
		list_fichier.back()->activate.connect(bind<bool>(slot(this->_Pappli, &Gbioseq::fShowLire),true));
	//	list_fichier.back()->activate.connect(slot(&_Pappli->_fichier, &FileSelection_SeqBio::fShowLire));
		list_fichier.push_back(MenuElem(_("_Open in new")));
		list_fichier.back()->activate.connect(bind<bool>(slot(this->_Pappli, &Gbioseq::fShowLire),false));

				//  list_fichier.back()->set_state(GTK_STATE_INSENSITIVE);
            // ^^^^^^^^

		// Modifying a slot
		list_fichier.push_back(MenuElem(_("_Save")));
		list_fichier.back()->activate.connect(slot(this->_Pappli, &Gbioseq::fShowEcrire));
//		list_fichier.push_back(MenuElem("Enregistrer", slot(&_Pappli->_fichier, &FileSelection_SeqBio::fShowEcrire))) ;//bind(slot(void_int_cb), 234)));
                                     //   ^^^^^^^^^^^^^^^^^^^^^^

		//  list_fichier.push_back(MenuElem("Enregistrer sous",slot(void_void_cb)));

		// setting an accelerator directly
//       list_file.push_back(MenuElem("_Fermer", CTL|'c', slot(void_void_cb)));
                                           // ^^^^^^^

/*		list_fichier.push_back(MenuElem(_("_Fermer")));
		list_fichier.back()->activate.connect(slot(_Pappli->_PongletADN, &OngletsGbioseq::Fermer_Onglet));
*/

		list_fichier.push_back(SeparatorElem());

		// setting an accelerator with a string
		list_fichier.push_back(MenuElem(_("_Quit"),"<control>q"));
		list_fichier.back()->activate.connect(slot(_Pappli, &Gbioseq::fQuitter));



		// Create the edit menu
		Menu *menu_editer                = manage( new Menu());
		MenuList& list_editer     = menu_editer->items();
		list_editer.push_back(MenuElem(_("Cut"), "<control>x"));
		list_editer.back()->activate.connect(slot(this->_Pappli, &Gbioseq::couper));
		
		list_editer.push_back(MenuElem(_("Copy"), "<control>c"));
//		list_editer.back()->activate.connect(bind<JeuSeqBio &, JeuSeqBio &>(slot(this->_Pappli, &Gbioseq::copier),_jeuseqBio, _jeuseqCopie));
		list_editer.back()->activate.connect(slot(this->_Pappli, &Gbioseq::copier));
		
		list_editer.push_back(MenuElem(_("Paste"), "<control>v"));
		list_editer.back()->activate.connect(slot(this->_Pappli, &Gbioseq::coller));

		list_editer.push_back(MenuElem(_("Rerverse complement"), "<control>r"));
		list_editer.back()->activate.connect(slot(this->_Pappli, &Gbioseq::f_reversecomplement));
//     list_editer.push_back(MenuElem("Options",*menu_sub));

		// Create the help menu
		Menu    *menu_help                = manage( new Menu());
		menu_help->items().push_back(MenuElem(_("About"), slot(*this,&MenuGbioseq::fApropos)));
	//	menu_help->items().push_back(MenuElem("About", slot(void_void_cb)));
    // Create the menu bar
     //   Gtk+ does not have O(1) tail lookups so you should build menus
     //   backwards whenever you plan to make lots of access to back().
		MenuList& list_bar = items();
		list_bar.push_front(MenuElem(_("_Help"),"<control>h",*menu_help));
		list_bar.front()->right_justify();
   //  items().push_front(MenuElem("E_xamples","<control>x",*menu_examples));
		items().push_front(MenuElem(_("_Edit"),"<control>e",*menu_editer));
		items().push_front(MenuElem(_("_File"),"<control>f",*menu_fichier));
	}
}
