/***************************************************************************
                          onglets.cpp  -  presentation en onglets
                          necessaire a gbioseq
                             -------------------
    begin                : ven 2 mai 10:25:55 CEST 2000
    copyright            : (C) 2000 by Olivier Langella CNRS UPR9034
    email                : Olivier.Langella@pge.cnrs-gif.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// modifi par Kelly Martinez en juillet et aout 2001

#include "onglets.h"

//using SigC::slot;
//using SigC::bind;

OngletsGbioseq::OngletsGbioseq(Gbioseq * Pappli): _Pappli(Pappli) {
	set_tab_pos (GTK_POS_TOP);
}

OngletsGbioseq::~OngletsGbioseq() {
//cerr << "OngletsGbioseq::~OngletsGbioseq()";
}

void OngletsGbioseq::NouvelOnglet( const string titre ) {
// cr un nouvel onglet
	AAmultiADN * PcadreADN(0);
	gint pos;
	JeuSeqBio jeuseq((unsigned int) 0);
	
	PcadreADN = manage( new AAmultiADN (jeuseq) ); // creation d'un nouveau pointeur sur AfficheV_ADN
	
	_tabPAfficheADN.push_back(PcadreADN);	// l'ajoute dans le tableau des pointeurs vers AfficheV_ADN
	pages().push_back(Gtk::Notebook_Helpers::TabElem(*PcadreADN,titre));	// met l'objet dans une nouvelle page
	pages().back()->set_tab_packing(true, true, GTK_PACK_START);	// parametres de la page

	pos = pages().size() - 1;	// position de la page courante
	set_page(pos);	// se met sur la page qui vient d'etre cre
	
	//	next_page();
//	PcadreADN->set_border_width (10);
//	PcadreADN->set_usize (100, 75);
//	PcadreADN->show ();
}


void OngletsGbioseq::AjouterCour_ADN( const JeuSeqBio & jeuseq ) {
// ajoute un jeu de squences  l'onglet courant
	AAmultiADN * PcadreADN(0);
	//bool ajout(true);
	string titre(_("new"));

//cerr << "OngletsGbioseq::Ajouter_ADN" << endl;
//cerr << get_current_page_num() << endl;
//cerr << jeuseq.size() << endl;


	if (pages().size() == 0) { //vrifie qu'il y a au moins un onglet
		NouvelOnglet(titre);
		set_page(0);	// se met sur la page qui vient d'etre cre
	}
	
	if (get_current_page_num() > -1) {		//verifie qu'il y a bien un onglet courant
		PcadreADN = _tabPAfficheADN[get_current_page_num()];
		PcadreADN->Ajouter_ADN(jeuseq);
		//if ((PcadreADN->getnbseq() == 0) || (ajout)) {	//permet de l'utiliser dans AjouterNouv_ADN
	//	pages().back()->set_tab_packing(true, true, GTK_PACK_START);
		//	return;
		//}
	}
}

	
void OngletsGbioseq::AjouterNouv_ADN(const JeuSeqBio & jeuseq, const string & titre ) {
// ajoute un jeu de squences dans un nouvel onglet

	NouvelOnglet( titre );
	AjouterCour_ADN( jeuseq );
}


/*void OngletsGbioseq::Fermer_Onglet() {
//ferme l'onglet courant
//   Gtk::Notebook::Page *page;
	AfficheV_ADN * PcadreADN(0);

//   page = get_current();
	if (get_current_page_num() > -1) {		//verifie qu'il y a bien un onglet courant
		PcadreADN = _tabPAfficheADN[get_current_page_num()];
cerr << PcadreADN->getnbseq();
		pages().remove(*(pages().begin()));
//		_tabPAfficheADN[get_current_page_num()];
	}

 //  draw(NULL);	//permet  l'objet de se redessiner
}
*/

/*void OngletsGbioseq::copier(JeuSeqBio & jeuseq) [
	_PAfficheV_ADN->copier(jeuseq);
]
*/

const JeuSeqADN * OngletsGbioseq::get_Pjeuseq() const {

	return(_tabPAfficheADN[get_current_page_num()]->get_Pjeuseq());
}

void OngletsGbioseq::get_seq_selectionnee(JeuSeqBio & jeuseq) const {
//cerr << "void OngletsGbioseq::get_seq_selectionnee(JeuSeqBio & jeuseq) debut";
	AAmultiADN * PcadreADN(0);

	jeuseq.reset();
	if (_tabPAfficheADN.size() == 0) { //vrifie qu'il y a au moins un onglet
		return;
	}
	if (get_current_page_num() > -1) {		//verifie qu'il y a bien un onglet courant
		PcadreADN = _tabPAfficheADN[get_current_page_num()];
		if (PcadreADN->getnbseq() == 0) return;
		else PcadreADN->get_seq_selectionnee(jeuseq);
	}
//cerr << "void OngletsGbioseq::get_seq_selectionnee(JeuSeqBio & jeuseq) fin";
	
}

void OngletsGbioseq::suppr_seq_selectionnee() {
	AAmultiADN * PcadreADN(0);

	if (_tabPAfficheADN.size() == 0) { //vrifie qu'il y a au moins un onglet
		return;
	}
	if (get_current_page_num() > -1) {		//verifie qu'il y a bien un onglet courant
		PcadreADN = _tabPAfficheADN[get_current_page_num()];
		if (PcadreADN->getnbseq() == 0) return;
		else PcadreADN->suppr_seq_selectionnee();
	}

}

void OngletsGbioseq::f_reversecomplement() {
	AAmultiADN * PcadreADN(0);

	if (_tabPAfficheADN.size() == 0) { //vrifie qu'il y a au moins un onglet
		return;
	}
	if (get_current_page_num() > -1) {		//verifie qu'il y a bien un onglet courant
		PcadreADN = _tabPAfficheADN[get_current_page_num()];
		if (PcadreADN->getnbseq() == 0) return;
		else PcadreADN->f_reversecomplement();
	}

}
